﻿Dim pole_color(64) ; значения полей 1 - белое и -1 - чёрное
UseJPEGImageDecoder() : UseJPEGImageEncoder()
LoadFont(0,"",15)
main_folder.s = GetCurrentDirectory()
data_folder.s = main_folder.s + "DATA/"
save_folder.s = main_folder.s + "SAVE/"
temp_folder.s = main_folder.s + "TEMP/"

SetCurrentDirectory(data_folder.s)
  For temp = 1 To 32
    LoadImage(temp, Str(temp) + ".jpg")
  Next
  image_size = ImageWidth(1)  
  
Gosub diagramm_clear    
Gosub create_main_window

;---process
process:
Repeat
event = WaitWindowEvent()

  If print_diagrama >= 4
    DisableGadget(85,1)
  Else
    DisableGadget(85,0)
  EndIf
  
  If GetActiveGadget() = 82 And GetGadgetText(82) = "Введите здесь текст задания"
    SetGadgetText(82,"")
  EndIf
  If GetActiveGadget() <> 82 And GetGadgetText(82) = ""
    SetGadgetText(82,"Введите здесь текст задания")
  EndIf

  If event = #PB_Event_CloseWindow : End : EndIf
  If event = #PB_Event_Gadget
    If EventGadget() > 68 And EventGadget() < 82
      select_figures_gadget = (EventGadget() - 68) * 2 - 1
    EndIf

    If EventGadget() = 88
      select_figures_gadget = 29
    EndIf

    If EventGadget() = 89
      select_figures_gadget = 31
    EndIf
        
    If EventGadget() > 0 And EventGadget() < 65
      If pole_color(EventGadget()) = 1
        SetGadgetState(EventGadget(), ImageID(select_figures_gadget))
      Else
        SetGadgetState(EventGadget(), ImageID(select_figures_gadget + 1))
      EndIf
    EndIf   
    
    If EventGadget() = 83
      Gosub window_output_board_image
    EndIf 
    
    If EventGadget() = 84
      Gosub add_diagrama
        file$ = SaveFileRequester("Save image",save_folder.s,"JPEG Image|*.jpg",0)
          If file$
          SaveImage(100, file$ + ".jpg",#PB_ImagePlugin_JPEG)
          EndIf
    EndIf 

    If EventGadget() = 85
      print_diagrama = print_diagrama + 1  : Gosub add_diagrama : SaveImage(100,Str(print_diagrama) + ".jpg",#PB_ImagePlugin_JPEG)  
    EndIf 
    
    If EventGadget() = 86
      Gosub erase_board :  SetGadgetText(82,"")
    EndIf 

    If EventGadget() = 87
      Gosub diagramm_clear
    EndIf 
        
  EndIf
ForEver
End

;---create_main_window
create_main_window:
new_gadget = 0
OpenWindow(0,1,1,800,620,"Chess diagram",#PB_Window_MinimizeGadget | #PB_Window_ScreenCentered)
temp1 = -1
  For temp = 1 To 8
    For temp0 = 1 To 8
      new_gadget = new_gadget + 1 ; 1 to 64 gadgets
      If temp1 = -1
        ImageGadget(new_gadget, temp * image_size, temp0 * image_size, image_size, image_size, ImageID(25))
      Else
        ImageGadget(new_gadget, temp * image_size, temp0 * image_size, image_size, image_size, ImageID(26))
      EndIf
     temp1 = -temp1
     pole_color(new_gadget) = temp1 ; запоминаем цвет поля
    Next
    temp1 = -temp1
  Next

ImageGadget(65,  image_size - image_size / 2, image_size / 2, image_size * 9 , image_size/ 2, ImageID(27))
ImageGadget(66, image_size - image_size / 2, image_size * 9, image_size * 9 , 25, ImageID(27))
ImageGadget(67, image_size - image_size / 2, image_size, image_size / 2  , image_size * 8, ImageID(28))
ImageGadget(68, image_size * 9, image_size, image_size / 2  , image_size * 8, ImageID(28))

For temp = 1 To 6
  ImageGadget(68 + temp, image_size * 10, image_size * temp + temp*3 - image_size/2 , image_size, image_size, ImageID(temp * 2 - 1))
Next

For temp = 1 To 6
  ImageGadget(74 + temp, image_size * 11 + 5, image_size * temp + temp*3 - image_size/2 , image_size, image_size, ImageID((temp + 6) * 2 - 1))
Next
ImageGadget(81, image_size * 12 + 10, image_size + 3 - image_size/2 , image_size, image_size, ImageID(25))

StringGadget(82,image_size / 2, image_size * 10 - image_size / 2 + 5, image_size * 9, 25, "Введите здесь текст задания")
  SetGadgetFont(82, FontID(0))
ButtonGadget(83, image_size * 10, image_size * 7 + 40, 790 - image_size * 10,25,"Просмотр и печать")
ButtonGadget(84, image_size * 10, image_size * 7 + 70, 790 - image_size * 10,25,"Сохранить изображение")

ButtonGadget(85, image_size * 10, image_size * 7 + 10, 790 - image_size * 10,25,"Добавить к печати")
ButtonGadget(86, image_size * 10, image_size * 7 + 100, 790 - image_size * 10,25,"Очистить доску")
ButtonGadget(87, image_size * 10, image_size * 7 + 130, 790 - image_size * 10,25,"Очистить диаграммы")

ImageGadget(88, image_size * 12 + 10, image_size * 2 + 6 - image_size/2 , image_size, image_size, ImageID(29))
ImageGadget(89, image_size * 12 + 10, image_size * 3 + 9- image_size/2 , image_size, image_size, ImageID(31))
SetActiveGadget(85)
Return

;---add_diagrama
add_diagrama:
SetCurrentDirectory(temp_folder.s)
CreateImage(100,image_size * 9, image_size * 9 + image_size / 2)
  StartDrawing(ImageOutput(100))
    DrawingMode(#PB_2DDrawing_Gradient) : Box(0,0,image_size *10, image_size * 10,RGB(255,255,255))    
    DrawingMode(#PB_2DDrawing_Outlined) : Box(0,0,image_size * 9, image_size / 2,RGB(0,0,0))
    DrawingFont(FontID(0))
    size_text = TextWidth(GetGadgetText(82))
    DrawText((image_size * 9 - size_text) / 2, image_size * 9 + 2, GetGadgetText(82),RGB(0,0,0),RGB(255,255,255))
    DrawImage(ImageID(27),0,0)
    DrawImage(ImageID(27),0,image_size * 8 + image_size / 2)
    DrawImage(ImageID(28),0,image_size / 2) : DrawImage(ImageID(28),image_size * 8 + image_size / 2, image_size / 2)
    get_image_gadget = 0
      For temp = 1 To 8
        For temp0 = 1 To 8
          get_image_gadget = get_image_gadget + 1
          DrawImage(GetGadgetState(get_image_gadget), temp * image_size - image_size / 2, temp0 * image_size - image_size / 2)
        Next
      Next
  StopDrawing()
Return

;---window_output_board_image 
window_output_board_image:
SetCurrentDirectory(temp_folder.s)
  krai_otstup = 40 : zentr_otstup = 20
  previons_view_size_x = 540 * 2 + krai_otstup * 2 + zentr_otstup
  previons_view_size_y = previons_view_size_x * 138 / 100
CreateImage(101, previons_view_size_x, previons_view_size_y)
  StartDrawing(ImageOutput(101))
    DrawingMode(#PB_2DDrawing_Gradient) : Box(0,0,previons_view_size_x +10, previons_view_size_y + 10,RGB(255,255,255))
    DrawingMode(#PB_2DDrawing_Outlined)
      For temp = 1 To print_diagrama
        LoadImage(99,Str(temp) + ".jpg")
          Select temp
            Case 1: DrawImage(ImageID(99),krai_otstup,krai_otstup)
            Case 2: DrawImage(ImageID(99),krai_otstup + ImageWidth(99) + zentr_otstup,krai_otstup)
            Case 3: DrawImage(ImageID(99),krai_otstup,krai_otstup + ImageHeight(99) + zentr_otstup)
            Case 4: DrawImage(ImageID(99),krai_otstup + ImageWidth(99) + zentr_otstup,krai_otstup + ImageHeight(99) + zentr_otstup)
          EndSelect        
      Next
  StopDrawing()

  OpenWindow(1,1,1, 1000,730,"",#PB_Window_MinimizeGadget | #PB_Window_ScreenCentered)
  ButtonGadget(201,425, 695,150,25,"Печать диаграмм")
  ScrollAreaGadget(199,0,0, 990, 680,previons_view_size_x, previons_view_size_y)
  ImageGadget(200,5,5,previons_view_size_x, previons_view_size_y,ImageID(101))

    Repeat
      event = WaitWindowEvent()
        If event = #PB_Event_CloseWindow : Break : EndIf
        If event = #PB_Event_Gadget
          If EventGadget() = 201
            If PrintRequester()
              StartPrinting("print diagram")
                StartDrawing(PrinterOutput())
                  ResizeImage(101, PrinterPageWidth(),PrinterPageHeight())
                  DrawImage(ImageID(101),0,0)
                StopDrawing()
              StopPrinting()
            EndIf
          EndIf
        EndIf
    ForEver
  CloseWindow(1)
Return

;---erase_board
erase_board:
new_gadget = 0
temp1 = -1
  For temp = 1 To 8
    For temp0 = 1 To 8
      new_gadget = new_gadget + 1 ; 1 to 64 gadgets
      If temp1 = -1
        SetGadgetState(new_gadget,ImageID(25))
      Else
        SetGadgetState(new_gadget,ImageID(26))
      EndIf
     temp1 = -temp1
    Next
    temp1 = -temp1
  Next
Return

;---diagramm_clear
diagramm_clear:
SetCurrentDirectory(temp_folder.s)
  CreateImage(0,5,5)
  StartDrawing(ImageOutput(0))
    DrawingMode(#PB_2DDrawing_Gradient) : Box(0,0,10, 10,RGB(255,255,255))
  StopDrawing()
    SaveImage(0,"1.jpg",#PB_ImagePlugin_JPEG)
    CopyFile("1.jpg","2.jpg") : CopyFile("1.jpg","3.jpg") : CopyFile("1.jpg","4.jpg")
 print_diagrama = 0
Return
; IDE Options = PureBasic 4.61 (Linux - x86)
; CursorPosition = 2
; EnableUnicode
; EnableXP