﻿UseJPEGImageDecoder() : UseJPEGImageEncoder()
main_dir.s = GetCurrentDirectory()
read_dir.s = main_dir.s + "SAVE/"
  krai_otstup = 30 : zentr_otstup = 20
  previons_view_size_x = 540 * 2 + krai_otstup * 2 + zentr_otstup * 2  ; ширина печатного листа
  previons_view_size_y = previons_view_size_x * 138 / 100              ; высота печатного листа
  image_width = (previons_view_size_x - (krai_otstup * 2 + zentr_otstup * 2)) / 3  ;  ширина диаграммы
  image_height = (previons_view_size_y - (krai_otstup * 2 + zentr_otstup * 3)) / 4  ;  высота диаграммы
  
  CreateImage(101, previons_view_size_x, previons_view_size_y)
  StartDrawing(ImageOutput(101))
    DrawingMode(#PB_2DDrawing_Gradient) : Box(0,0,previons_view_size_x +10, previons_view_size_y + 10,RGB(255,255,255))
    DrawingMode(#PB_2DDrawing_Outlined)     
  StopDrawing()
  
  OpenWindow(1,1,1, 1000,700,"",#PB_Window_MinimizeGadget | #PB_Window_ScreenCentered)  
  ButtonGadget(201,25, 10,150,25,"Печать диаграмм")
  ButtonGadget(202,205, 10,150,25,"Добавить диаграмму")
  ButtonGadget(203,385, 10,200,25,"Сохранить диаграммы в JPG")
  ButtonGadget(204,615, 10,200,25,"Очистить диаграммы") 
  ScrollAreaGadget(199,5,40, 990, 640,previons_view_size_x, previons_view_size_y)
  ImageGadget(200,0,0,previons_view_size_x, previons_view_size_y,ImageID(101))
all_image = 0

;---process
process:
    Repeat
      event = WaitWindowEvent()
        If event = #PB_Event_CloseWindow : Break : EndIf
        If event = #PB_Event_Gadget
          If EventGadget() = 201
            If PrintRequester()
              StartPrinting("print diagram")
                StartDrawing(PrinterOutput())
                  ResizeImage(101, PrinterPageWidth(),PrinterPageHeight())
                  DrawImage(ImageID(101),0,0)
                StopDrawing()
              StopPrinting()
            EndIf
          EndIf
          
          If EventGadget() = 202 : Gosub load_image : EndIf
          If EventGadget() = 203 : Gosub save_image : EndIf
          If EventGadget() = 204 : Gosub clear_image : DisableGadget(202,0) : EndIf
        If all_image >= 12 : DisableGadget(202,1) : EndIf
        EndIf
    ForEver
  CloseWindow(1)
  End
  
;---drawing
drawing:
    StartDrawing(ImageOutput(101))
    DrawingMode(#PB_2DDrawing_Outlined)        
          Select all_image
            Case 1:  DrawImage(ImageID(99),krai_otstup,krai_otstup)
            Case 2:  DrawImage(ImageID(99),krai_otstup + ImageWidth(99) + zentr_otstup,krai_otstup)
            Case 3:  DrawImage(ImageID(99),krai_otstup + ImageWidth(99) * 2 + zentr_otstup * 2,krai_otstup)
            Case 4:  DrawImage(ImageID(99),krai_otstup,krai_otstup + ImageHeight(99) + zentr_otstup)
            Case 5:  DrawImage(ImageID(99),krai_otstup + ImageWidth(99) + zentr_otstup,krai_otstup + ImageHeight(99) + zentr_otstup)
            Case 6:  DrawImage(ImageID(99),krai_otstup + ImageWidth(99) * 2 + zentr_otstup * 2,krai_otstup + ImageHeight(99) + zentr_otstup)
            Case 7:  DrawImage(ImageID(99),krai_otstup,krai_otstup + ImageHeight(99) * 2 + zentr_otstup * 2)
            Case 8:  DrawImage(ImageID(99),krai_otstup + ImageWidth(99) + zentr_otstup,krai_otstup + ImageHeight(99) * 2 + zentr_otstup * 2)
            Case 9:  DrawImage(ImageID(99),krai_otstup + ImageWidth(99) * 2 + zentr_otstup * 2,krai_otstup + ImageHeight(99) * 2 + zentr_otstup * 2)
            Case 10: DrawImage(ImageID(99),krai_otstup,krai_otstup + ImageHeight(99) * 3 + zentr_otstup * 3)
            Case 11: DrawImage(ImageID(99),krai_otstup + ImageWidth(99) + zentr_otstup,krai_otstup + ImageHeight(99) * 3 + zentr_otstup * 3)
            Case 12: DrawImage(ImageID(99),krai_otstup + ImageWidth(99) * 2 + zentr_otstup * 2,krai_otstup + ImageHeight(99) * 3 + zentr_otstup * 3)
          EndSelect        
     StopDrawing()
     SetGadgetState(200, ImageID(101))
Return
  
;---load_image
load_image:
open_image.s = OpenFileRequester("Open image", read_dir.s, "Image JPG|*.jpg",0)
If open_image.s
  all_image = all_image + 1
  LoadImage(99, open_image.s)
  koeffizient_x.d = ImageWidth(99) / image_width
  koeffizient_y.d = ImageHeight(99) / image_height
    If koeffizient_x > koeffizient_y
      ResizeImage(99, ImageWidth(99) / koeffizient_x, ImageHeight(99) / koeffizient_x)
    Else
      ResizeImage(99, ImageWidth(99) / koeffizient_y, ImageHeight(99) / koeffizient_y)
    EndIf
  Gosub drawing
EndIf
Return

;---save_image
save_image:
save_jpg = SaveImage(101, SaveFileRequester("Save image", GetHomeDirectory(),".jpg",0), #PB_ImagePlugin_JPEG)
If save_jpg : EndIf
Return

;---clear_image
clear_image:
all_image = 0
StartDrawing(ImageOutput(101))
  DrawingMode(#PB_2DDrawing_Gradient) : Box(0,0,previons_view_size_x +10, previons_view_size_y + 10,RGB(255,255,255))  
StopDrawing()
SetGadgetState(200, ImageID(101))
Return
; IDE Options = PureBasic 4.61 (Linux - x86)
; CursorPosition = 3
; EnableUnicode
; EnableXP